#!/bin/sh
# Run this to generate all the initial makefiles, etc.

PROJECT=JabberX
TEST_TYPE=-f
FILE=configure.in

srcdir=`dirname $0`
test -z "$srcdir" && srcdir=.
build_dir=`pwd`

DIE=0

(autoconf --version) < /dev/null > /dev/null 2>&1 || {
	echo
	echo "You must have autoconf installed to compile $PROJECT."
	echo "Download the appropriate package for your distribution,"
	echo "or get the source tarball at ftp://ftp.gnu.org/pub/gnu/"
	DIE=1
}

(automake --version) < /dev/null > /dev/null 2>&1 || {
	echo
	echo "You must have automake installed to compile $PROJECT."
	echo "Get ftp://ftp.cygnus.com/pub/home/tromey/automake-1.2d.tar.gz"
	echo "(or a newer version if it is available)"
	DIE=1
}

if test "$DIE" -eq 1; then
	exit 1
fi

test $TEST_TYPE $srcdir/$FILE || {
	echo "You must run this script in the top-level $PROJECT directory"
	exit 1
}

case $CC in
*lcc | *lcc\ *) am_opt=--include-deps;;
esac

#echo "Running gettextize...  Ignore non-fatal messages."
# Hmm, we specify --force here, since otherwise things don't
# get added reliably, but we don't want to overwrite intl
# while making dist.
# echo "no" | gettextize --copy --force

( cd $srcdir;
	aclocal $ACLOCAL_FLAGS

# optionally feature autoheader
	(autoheader --version)  < /dev/null > /dev/null 2>&1 && autoheader

	automake -a $am_opt
	autoconf
) || exit $?
