/*
** JabberX (Jabber Client)
** Copyright (c) 1999-2001 Gurer Ozen <palpa@jabber.org>
**               2001 Bernhard R. Link <brl@pcpool00.mathematik.uni-freiburg.de>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
** Execute of notifications
*/

#include "common.h"
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/wait.h>
#include <fcntl.h>
#include <errno.h>


void on_exec(char *command)
{
	pid_t res;int status;

	 if (command == 0)
		 return; 

	res=fork();

	if( res < 0 ) 
		return;

	if ( res == 0 ) {
		char *argv[4];
		close(0);
		close(1);
		close(2);
		close(3);
		if(open("/dev/null",O_RDONLY)!=0)
			exit(126);
		if( prf.logfile )
		{
			if( open(prf.logfile,O_WRONLY|O_CREAT|O_APPEND,S_IRWXU) != 1 || dup2(1,2)!=2 ) 
				exit(125);

		}
		else
		{
			if( open("/dev/null",O_WRONLY) != 1 || dup2(1,2)!=2 ) 
				exit(125);
		}

		argv[0] = "sh";
		argv[1] = "-c";
		argv[2] = command;
		argv[3] = 0;
		execve("/bin/sh", argv, NULL);
		exit(127);
	} else {{
		if (waitpid(res, &status, 0) == -1) {
			if (errno == EINTR)
				return;
		} else
			return;
	} while(1);}
}
