/*
** JabberX (Jabber Client)
** Copyright (c) 1999-2001 Gurer Ozen <palpa@jabber.org>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
** groupchat
*/

#include "common.h"

#ifdef HAVE_SG
#include <assert.h>
#include <openssl/evp.h>
#endif


void cmd_join(char *arg)
{
	iks *x;
	iksid *id;
	textbuf *tb;

	id = iks_id_new(NULL, arg);
	if(!id || !id->user || !id->server)
	{
		gui_attr(GA_NOTICE);
		gui_print("Channel jid is invalid.\n");
              if (!options.compact_lines)
                 gui_print ("\n");
		return;
	}
	if(!id->resource) id->resource = net.id->user;


#ifdef HAVE_SG
	 if (keystoneclient.numGrps < MAX_GROUPS)
	 {
		 int len;
		 
		/*
		 * allocate memory for the grpName
		 */
		 
		 len = strlen(arg);
		 
		keystoneclient.grpName[keystoneclient.numGrps]= (char *) malloc(sizeof(char) * len);
		if (keystoneclient.grpName[keystoneclient.numGrps] == NULL)
		{
			ui_print(tb, "error allocating memory...........\n");
			return;
		}

		strncpy(keystoneclient.grpName[keystoneclient.numGrps], arg, len);

		keystoneclient.grpName[keystoneclient.numGrps][len] = 0;
		
		keystoneclient.request[keystoneclient.numGrps] = JOIN_GRP;
		keystoneclient.numGrps++;
		reqGroups(keystoneclient.ksCtx, keystoneclient.numGrps, keystoneclient.grpName, keystoneclient.request);
	}
	 else
		 ui_print(tb,"problem: MAX_GROUPS should be increased\n");

#if 0
	 {
		 int i = 0;
	for (i = 0; i < keystoneclient.numGrps; i++) {
	     Key *key;
	     int size;
	     char buf[80];
	     key = getGroupKey(keystoneclient.ksCtx, keystoneclient.grpName[i], 0);
	     if (key == NULL)
	         continue;
	
	     printf("Key %s %d(%d): ", keystoneclient.grpName[i], key->keyID, key->version);
	     size = mputKey(key, buf);
             dumpKey(buf, size);
        }
	 }
#endif
#endif
	
	tb = ui_buffer_new();
	tb->type = TB_GCHAT;
	tb->id = id;
	ui_buffer_show(tb);

	ui_print(tb, "Joining %s@%s...\n", id->user, id->server);

	x = iks_make_pres(IKS_TYPE_SET, IKS_SHOW_AVAILABLE, iks_id_print(id), NULL);
	iks_send(net.parser, x);
	iks_delete(x);
#if 0
	keystoneclient.grpName[keystoneclient.numGrps] = arg;
	keystoneclient.request[keystoneclient.numGrps] = JOIN_GRP;
	ui_print(tb, "num %d gprName %s req %d\n", keystoneclient.numGrps, keystoneclient.grpName[keystoneclient.numGrps], keystoneclient.request[keystoneclient.numGrps]);
	reqGroups(keystoneclient.ksCtx, keystoneclient.numGrps+1,keystoneclient.grpName , keystoneclient.request);

	exit(0);

	 {
		 int i = 0;
	for (i = 0; i < keystoneclient.numGrps; i++) {
	     Key *key;
	     int size;
	     char buf[80];
	     key = getGroupKey(keystoneclient.ksCtx, keystoneclient.grpName[i], 0);
	     if (key == NULL)
	         continue;
	
	     printf("Key %s %d(%d): ", keystoneclient.grpName[i], key->keyID, key->version);
	     size = mputKey(key, buf);
             dumpKey(buf, size);
        }
	 }
#endif
 	 
	

}


void cmd_nick(char *arg)
{
	iks *x = NULL;
        iksid *new = NULL;
        iksid *old = NULL;

	if(curbuf->type != TB_GCHAT) 
        {
                 goto usage;
        }

        if(!arg || *arg == '\0') {
                  goto usage;
        }

        new = iks_id_new(NULL, iks_id_printx(curbuf->id, IKS_ID_USER | IKS_ID_SERVER));
        new->resource = strdup(arg);

	x = iks_make_pres(IKS_TYPE_SET, IKS_SHOW_AVAILABLE, iks_id_print(new), NULL);
	iks_send(net.parser, x);
        iks_delete(x);

        old = curbuf->id;
        curbuf->id = new;
        /* FIXME: delete old id */

        return;

 usage:
        gui_attr(GA_NOTICE);
        gui_print("Usage: nick <new-nick>\n");
}

void cmd_part(char *arg)
{
	iks *x;
        iksid *id;

        id = iks_id_new(NULL, arg);
        if(!id || !id->user || !id->server) return;

	if(curbuf->type != TB_GCHAT) return;

	x = iks_make_pres(IKS_TYPE_SET, IKS_SHOW_UNAVAILABLE, iks_id_printx(curbuf->id, IKS_ID_USER | IKS_ID_SERVER), NULL);
	iks_send(net.parser, x);
	iks_delete(x);

	ui_buffer_delete(curbuf);

#ifdef HAVE_SG 
	 if (keystoneclient.numGrps < MAX_GROUPS)
	 {
		 int numGrps = 0;
		 int len = strlen(arg);

		 while(numGrps < keystoneclient.numGrps)
		 {
			 if (strncmp(keystoneclient.grpName[numGrps], arg, len) == 0) {
				 keystoneclient.request[numGrps] = LEAVE_GRP;
				 break;
			 }

			 numGrps++;
		 }
		 
		reqGroups(keystoneclient.ksCtx, numGrps+1, keystoneclient.grpName, keystoneclient.request);

		free(keystoneclient.grpName[numGrps]);
	 }
#endif
	

}

void print_hex (textbuf *tb, unsigned char *bs, unsigned int n)
{
	  int i;

	    for(i = 0; i < n; i++)
		          ui_print (tb, "%02x", bs[i]);
}


#ifdef HAVE_SG


static unsigned char basis_64[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/";

int base64encode(const unsigned char *input, int input_length, unsigned char *output, int output_length)
{
	int	i = 0, j = 0;
	int	pad;

//	assert(output_length >= (input_length * 4 / 3));

	while (i < input_length) {
		pad = 3 - (input_length - i);
		if (pad == 2) {
			output[j  ] = basis_64[input[i]>>2];
			output[j+1] = basis_64[(input[i] & 0x03) << 4];
			output[j+2] = '=';
			output[j+3] = '=';
		} else if (pad == 1) {
			output[j  ] = basis_64[input[i]>>2];
			output[j+1] = basis_64[((input[i] & 0x03) << 4) | ((input[i+1] & 0xf0) >> 4)];
			output[j+2] = basis_64[(input[i+1] & 0x0f) << 2];
			output[j+3] = '=';
		} else{
			output[j  ] = basis_64[input[i]>>2];
			output[j+1] = basis_64[((input[i] & 0x03) << 4) | ((input[i+1] & 0xf0) >> 4)];
			output[j+2] = basis_64[((input[i+1] & 0x0f) << 2) | ((input[i+2] & 0xc0) >> 6)];
			output[j+3] = basis_64[input[i+2] & 0x3f];
		}
		i += 3;
		j += 4;
	}
	return j;
}

/* This assumes that an unsigned char is exactly 8 bits. Not portable code! :-) */
static unsigned char index_64[128] = {
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,   62, 0xff, 0xff, 0xff,   63,
      52,   53,   54,   55,   56,   57,   58,   59,   60,   61, 0xff, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff,    0,    1,    2,    3,    4,    5,    6,    7,    8,    9,   10,   11,   12,   13,   14,
      15,   16,   17,   18,   19,   20,   21,   22,   23,   24,   25, 0xff, 0xff, 0xff, 0xff, 0xff,
    0xff,   26,   27,   28,   29,   30,   31,   32,   33,   34,   35,   36,   37,   38,   39,   40,
      41,   42,   43,   44,   45,   46,   47,   48,   49,   50,   51, 0xff, 0xff, 0xff, 0xff, 0xff
};

#define char64(c)  ((c > 127) ? 0xff : index_64[(c)])

int base64decode(const unsigned char *input, int input_length, unsigned char *output, int output_length)
{
	int		i = 0, j = 0, pad;
	unsigned char	c[4];

//	assert(output_length >= (input_length * 3 / 4));
//	assert((input_length % 4) == 0);
	while ((i + 3) < input_length) {
		pad  = 0;
		c[0] = char64(input[i  ]); pad += (c[0] == 0xff);
		c[1] = char64(input[i+1]); pad += (c[1] == 0xff);
		c[2] = char64(input[i+2]); pad += (c[2] == 0xff);
		c[3] = char64(input[i+3]); pad += (c[3] == 0xff);
		if (pad == 2) {
			output[j++] = (c[0] << 2) | ((c[1] & 0x30) >> 4);
			output[j]   = (c[1] & 0x0f) << 4;
		} else if (pad == 1) {
			output[j++] = (c[0] << 2) | ((c[1] & 0x30) >> 4);
			output[j++] = ((c[1] & 0x0f) << 4) | ((c[2] & 0x3c) >> 2);
			output[j]   = (c[2] & 0x03) << 6;
		} else {
			output[j++] = (c[0] << 2) | ((c[1] & 0x30) >> 4);
			output[j++] = ((c[1] & 0x0f) << 4) | ((c[2] & 0x3c) >> 2);
			output[j++] = ((c[2] & 0x03) << 6) | (c[3] & 0x3f);
		}
		i += 4;
	}
	return j;
}


int EncryptString(in,out,key,plainlen)
char *in,*out;
unsigned char *key;
int plainlen;
{
        int cipherlen, tmplen;
 unsigned char iv[8] = {1,2,3,4,5,6,7,8};
 EVP_CIPHER_CTX ctx;

EVP_CIPHER_CTX_init(&ctx);
EVP_EncryptInit(&ctx,EVP_bf_cbc(),key,iv);

if (!EVP_EncryptUpdate(&ctx,out,&cipherlen,in,plainlen))
   {
   return -1;
   }

if (!EVP_EncryptFinal(&ctx,out+cipherlen,&tmplen))
   {
   return -1;
   }

cipherlen += tmplen;
EVP_CIPHER_CTX_cleanup(&ctx);
return cipherlen;
}

int DecryptString(in,out,key,cipherlen)
char *in,*out;
unsigned char *key;
int cipherlen;
{
        int plainlen, tmplen;
  unsigned char iv[8] = {1,2,3,4,5,6,7,8};
  EVP_CIPHER_CTX ctx;

EVP_CIPHER_CTX_init(&ctx);
EVP_DecryptInit(&ctx,EVP_bf_cbc(),key,iv);

if (!EVP_DecryptUpdate(&ctx,out,&plainlen,in,cipherlen))
   {
   return -1;
   }

if (!EVP_DecryptFinal(&ctx,out+plainlen,&tmplen))
   {
   return -2;
   }

plainlen += tmplen;

EVP_CIPHER_CTX_cleanup(&ctx);
return plainlen;
}

#endif


void gchat_send(textbuf *tb, char *msg)
{
	iks *x;
	
#ifdef HAVE_SG
	unsigned char encmsg[1024];
	unsigned char base64encmsg[2*1024];

	int len = strlen(msg);
	int base64len = 0;
	int i = 0;
	Key *key;
	int size;
	char buf[80];
	
	key = getGroupKey(keystoneclient.ksCtx,iks_id_printx(tb->id, IKS_ID_USER), 0);
	     if (key == NULL)
	     {
		     ui_print(tb, "key seems to be empty..........\n");
		     return;
	     }
	
	     size = mputKey(key, buf);
             //dumpKey(buf, size);
        

	len = EncryptString(msg, encmsg, buf, len);

	if (len < 0)
	{
		ui_print(tb,"encryption of the string gone wrong\n");
		return;
	}
	
	base64len = base64encode(encmsg, len, base64encmsg, len);

	if (base64len < 0)
	{
		ui_print(tb,"base64 of the string gone wrong\n");
		return;
	}
	
	base64encmsg[base64len] = 0;

	
	

	x = iks_make_msg(IKS_TYPE_GROUPCHAT, iks_id_printx(tb->id, IKS_ID_USER | IKS_ID_SERVER), base64encmsg, tb->thread);
#else
#endif
//	x = iks_make_msg(IKS_TYPE_GROUPCHAT, iks_id_printx(tb->id, IKS_ID_USER | IKS_ID_SERVER), msg, NULL);
	iks_send(net.parser, x);
	iks_delete(x);
#ifdef HAVE_SG1
	free (base64encmsg);
	free(encmsg);
#endif
}


void gchat_msg(ikspak *pak)
{
        textbuf *tb;
  
        tb = target_textbuf(pak);

        if (!tb) {
                /* invite? */
                 return;
        }

	if(pak->from->resource)
	{
#ifdef HAVE_SG
	unsigned char base64decmsg[2*1024];
	unsigned char encmsg[1024];
	unsigned char decmsg[1024];
	int base64len = 0;
	int len = 0;
	int i = 0;
	Key *key;
	int size;
	char buf[80];
	
	key = getGroupKey(keystoneclient.ksCtx,iks_id_printx(tb->id, IKS_ID_USER), 0);
	     if (key == NULL)
	     {
		     ui_print(tb, "key seems to be empty..........\n");
		     return;
	     }
	
	     size = mputKey(key, buf);
        
	base64len = strlen(iks_find_cdata(pak->x, "body"));
		
	base64len = base64decode(iks_find_cdata(pak->x, "body"), base64len, encmsg, base64len);

	len = DecryptString(encmsg,decmsg, buf, base64len);
	

	if (len < 0)
	{
		ui_print(tb, "decryption of the string gone wrong error %d\n", len);
		return;
	}

	decmsg[len] = 0;
		ui_print(tb, "<%s> %s\n", pak->from->resource, decmsg);
#else
		ui_print(tb, "<%s> %s\n", pak->from->resource,iks_find_cdata(pak->x, "body"));
#endif
	
	}
	else
		ui_print(tb, "*** %s\n", iks_find_cdata(pak->x, "body"));

}

void gchat_whisper(textbuf *tb, ikspak *pak)
{
	ui_print(tb, "<%s -> %s> %s\n", pak->from->resource, tb->id->resource, iks_find_cdata(pak->x, "body"));
        ui_set_tab_content("/w %s", pak->from->resource);
}
        
textbuf *target_textbuf(ikspak *pak) 
{
        textbuf *tb;

	for(tb = list_first(&textbufs); tb; tb = list_next(tb))
	{
		if(iks_id_cmpx(pak->from, tb->id, IKS_ID_USER | IKS_ID_SERVER) == 0)
                         return tb;
	}

        return NULL;
}

void cmd_whisper(char *arg) 
{
        iks *x;
        iksid *w;
        char *tokarg = strdup(arg);
        char *to, *body;

	if(curbuf->type != TB_GCHAT)
        {
                  goto usage;
        }

        if(!arg || *arg == '\0') {
                  goto usage;
        }

        to = strtok(tokarg, " ");
        body = strtok(NULL, "");

        if(!to || !body) {
                  goto usage;
        }

        w = iks_id_new(NULL, iks_id_printx(curbuf->id, IKS_ID_USER | IKS_ID_SERVER));
        w->resource = to;

        x = iks_make_msg(IKS_TYPE_CHAT, iks_id_print(w), body, NULL);
	iks_send(net.parser, x);
	iks_delete(x);

	ui_print(curbuf, "<%s -> %s> %s\n", curbuf->id->resource, w->resource, body);
        ui_set_tab_content("/w %s", w->resource);
        goto cleanup;

 usage:
        gui_attr(GA_NOTICE);
        gui_print("Usage: whisper <nick> <message>\n");
        gui_print("[only works in chat rooms]\n");

 cleanup:
        free(tokarg);
}

int gchat_pres(ikspak *pak)
{
	textbuf *tb;
	char *tmp;

	tb = list_first(&textbufs);
	while(tb)
	{
		if(iks_id_cmpx(pak->from, tb->id, IKS_ID_USER | IKS_ID_SERVER) == 0)
			break;
		tb = list_next(tb);
	}
	if(!tb) return(0);

	switch(pak->show)
	{
	case IKS_SHOW_UNAVAILABLE: tmp = "unavailable."; break;
	case IKS_SHOW_AVAILABLE: tmp = "available."; break;
	case IKS_SHOW_AWAY: tmp = "away."; break;
	case IKS_SHOW_XA: tmp = "xa."; break;
	case IKS_SHOW_DND: tmp = "dnd."; break;
	case IKS_SHOW_CHAT: tmp = "ready for chat."; break;
	default: tmp = "(unknown status)"; break;
	}

	ui_print(tb, "*** %s is %s\n", pak->from->resource, tmp);

	return 1;
}
