/*
** JabberX (Jabber Client)
** Copyright (c) 1999-2001 Gurer Ozen <palpa@jabber.org>
**
** This code is free software; you can redistribute it and/or
** modify it under the terms of the GNU General Public License.
**
** main entry point
*/

#include <locale.h>
#include "common.h"
#include <math.h>
#include <time.h>

int main(int argc, char *argv[])
{
#ifdef HAVE_SG
 char *ctxFile, *keyFile, *certFile, *caFile, *caPath;

 /* initialize the values */
  keyFile = def_keyFile;
  certFile = def_certFile;
  caFile = def_caFile;
  caPath = def_caPath;
  ctxFile = def_ctxFile; 
#endif
	
	setlocale(LC_ALL, "");

        srand(time(0));
	
#ifdef HAVE_SG
	j_setup(ctxFile, keyFile, certFile, caFile, caPath);
#else
	j_setup();
#endif
	prf_setup(argc, argv);

	pl_setup();

	if(!prf.user)
	{
		fprintf(stderr, "error: username required!\n");
		return 1;
	}

	if(!prf.pass)
	{
		fprintf(stderr, "error: password required!\n");
		return 1;
	}


	ui_run();


	pl_cleanup();

	return 0;
}
